; The program gets 10 numbers from the user < 255
; that will store, then will sort them ascending
; and output to screen

; Header...
dosseg
.model small
.stack
; initialized data section
.data
    

    ; a counter
    COUNTER       dw      10
    ; numbers count
    NrNr            dw      0
    ; iterator (pointer)
    pNr             dw      0
    ; buffer used to store initial list
    ListOfNumbers     db      10 dup (0)
    ; buffer to store sorted list
    ListOfNumbersS    db      10 dup (0)
    
    
    ; input buffer
    strNumberCrt     DB      10,  10 dup (0)
    
    ; ===============================
    ; messages
    strWelcome      db      13,10,13,10
                    db      "--------------------------------------------------",13,10
                    db      " Sorting program",13,10
                    db      "--------------------------------------------------",13,10
                    db      13,10
                    db      "Type first number 0-255]:$"
                    
    stGetMeNumbers  db      13,10,"Type next number [0-255]:$"
    strAnswer       db      13,10,"Sorted list of numbers:$"
    
    strBye          db      13,10
                    db      13,10
                    db      "--------------------------------------------------",13,10
                    db      " Execution has ended",13,10
                    db      "--------------------------------------------------"
                    db      13,10
                    db      13,10
                    db      "$"
                    
    Er_Nn db 13,10,'ERROR!!! Input string does not represent a number!$'
    Er_Rng db 13,10,'ERROR!!! Input number is outside allowed range!$'
    
    ; ===============================
    

.code
ProgStart:

    ; set data segment
    mov     ax,     @data
    mov     ds,     ax

    ; show welcome message
    mov     ah,     09
    mov     dx,     offset strWelcome
    int     21h


Get_Number:
    ; read input
        mov     ah,     0ah
        mov     dx,     offset strNumberCrt
        int     21h


    ; get number of characters
        mov     cl,     strNumberCrt[1]
        inc     cl
        mov     si,     1
        ; ax = 0
        xor     ax,     ax
        ; multiply by 10 each time
        mov     bx,     10


    ; convert from text to number
Conv2Txt:
        mul     bl
        inc     si
        mov     dl,     strNumberCrt[si]
        ; check if this is numeric
        sub     dl,     30h
        jb      Err_Nan
        cmp     dl,     9
        ja      Err_Nan
        add     ax,     dx
        ; are we at the end?
        cmp     si,     cx
        jne     Conv2Txt
        ; ax has the number


    ; check if inside bounds
        cmp     ax,     255
        ja      Err_Range

    ; save the number
        push    si
        mov     si,     NrNr
        mov     cx,     si
        mov     [ListOfNumbers][si],al
        cmp     cx,     9
        pop     si
        je      All_Numbers_In_Buffer
    
    ; get back and get another number
        add     NrNr,   1
        mov     ah,     09
        mov     dx,     offset stGetMeNumbers
        int     21h
        jmp Get_Number


    ; error messages
Err_Nan:
    mov     dx,     offset Er_Nn
    jmp     @F
Err_Range:
    mov     dx,     offset Er_Rng
@@: mov     ah,     09
    int     21h
    mov     ah,     09
    mov     dx,     offset stGetMeNumbers
    int     21h
    jmp     Get_Number

All_Numbers_In_Buffer:
    add     NrNr,       1
        
;========================================================= 
;========================================================= 
;=====               S O R T I N G                   ===== 
;========================================================= 
;========================================================= 

    ; prepare to sort
        mov     di,         offset  ListOfNumbersS
        push    NrNr
        pop     COUNTER

LoopInVal:
        xor     si,         si

        mov     al,         byte ptr ListOfNumbers[si]
        mov     dx,         si
        add     si,         1
@@:
        cmp     al,         byte ptr ListOfNumbers[si]
        ja      Is_Smaller
        add     si,         1
        cmp     si,         NrNr
        jb      @B
        
        jmp     EndOfMin
        
Is_Smaller:
        mov     dx,         si
        mov     al,         byte ptr ListOfNumbers[si]
        add     si,         1
        cmp     si,         NrNr
        jb      @B
        
EndOfMin:
        mov     si,         dx
        mov     byte ptr ListOfNumbers[si],255
        mov     byte ptr [di],al
        add     di,         1
        sub     COUNTER,  1
        jnz     LoopInVal
;========================================================= 
;========================================================= 
;========================================================= 
;========================================================= 
        
        
        
; show final message
        mov     ah,         9
        mov     dx,         offset strAnswer
        int     21h
        
        mov     di,         offset ListOfNumbersS

Show_Result:
        xor     ax,             ax
        mov     al,             byte ptr [di]
        mov     bx,             10
        xor     dx,             dx
    
    ; CONVERT FROM NUMBER TO TEXT 
        xor     si,             si
    A_Digit:
        div     bx ; / 10
        add     dl,             30h
        mov     strNumberCrt[si], dl
        inc     si
        xor     dx,             dx
        cmp     ax,             0
        jne     A_Digit
    
    character:
        dec     si
        mov     ah,             02
        mov     dl,             strNumberCrt[si]
        int     21h
        cmp     si,     0
        jne     character
    
        add     di,             1
        sub     NrNr,           1
        jz      @F
        mov     ah,             02
        mov     dl,             ","
        int     21h
        mov     ah,             02
        mov     dl,             " "
        int     21h
        jmp     Show_Result
        @@:

    ; FINAL MESSAGE
    mov     ah,             9
    mov     dx,             offset strBye
    int     21h
    mov     ah,     4ch
    int     21h
END ProgStart
